﻿Public Class MyRenderTransformHelper
    Inherits DependencyObject


    Public Shared Function GetAngle(ByVal element As DependencyObject) As Double
        If element Is Nothing Then
            Throw New ArgumentNullException("element")
        End If

        Return CDbl(element.GetValue(AngleProperty))
    End Function

    Public Shared Sub SetAngle(ByVal element As DependencyObject, ByVal value As Double)
        If element Is Nothing Then
            Throw New ArgumentNullException("element")
        End If

        element.SetValue(AngleProperty, value)
    End Sub

    Public Shared ReadOnly AngleProperty As _
                           DependencyProperty = DependencyProperty.RegisterAttached("Angle",
                           GetType(Double), GetType(MyRenderTransformHelper),
                           New PropertyMetadata(Double.Parse("0"), AddressOf AngleProperty_Changed))
    Private Shared Sub AngleProperty_Changed(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
        Dim elem As UIElement = TryCast(d, UIElement)
        If elem IsNot Nothing Then
            elem.RenderTransformOrigin = New Point(0.5, 0.5)
            elem.RenderTransform = New RotateTransform(CDbl(e.NewValue))
        End If

    End Sub

End Class
