﻿Public Class WindowHelper
    Inherits DependencyObject

    Public Shared Function GetWindowTitle(obj As UserControl) As String
        Return DirectCast(obj.GetValue(WindowTitleProperty), String)
    End Function
    Public Shared Sub SetWindowTitle(obj As UserControl, value As String)
        obj.SetValue(WindowTitleProperty, value)
    End Sub
    Public Shared ReadOnly WindowTitleProperty As DependencyProperty =
        DependencyProperty.RegisterAttached("WindowTitle",
                                            GetType(String),
                                            GetType(WindowHelper),
                                            New UIPropertyMetadata("", AddressOf WindowTitle_Changed))
    Private Shared Sub WindowTitle_Changed(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
        Dim ctl = TryCast(d, UserControl)
        AddHandler ctl.Loaded, Sub(sender, e2)
                                   If Window.GetWindow(ctl) IsNot Nothing Then
                                       DirectCast(Window.GetWindow(ctl), Window).Title = GetWindowTitle(ctl)
                                   End If
                               End Sub
    End Sub

End Class
